<?php
/*
 *  Created by Michael Tyson on 1/01/09.
 *  Copyright 2009 Michael Tyson. All rights reserved.
 */
    
function prepareCurrencies() {
    global $currencyRates;
    
    $path = "/tmp/currencyRates.dat";
    if ( file_exists($path) && filemtime($path) > (time() - (24*60*60)) ) {
        // Load cached version
        $currencyRates = unserialize(file_get_contents($path));
        if ( $currencyRates ) return;
    }
    
    $currencyRates = array();
    
    $fd = fopen("http://rss.timegenie.com/forex.txt", "r");
    if ( !$fd ) return false;
    
    $content = "";
    while ( !feof($fd) ) {
        $line = explode("|", trim(fgets($fd)));
        $rates[$line[0]] = $line[2];
    }
    
    foreach ( $rates as $currency => $rate ) {
        foreach ( $rates as $currency2 => $rate2 ) {
            if ( !$rate || !$rate2 ) continue;
            $currencyRates[$currency][$currency2] = $rate / $rate2;
        }
    }
    
    $fd = fopen($path, "w");
    fwrite($fd, serialize($currencyRates));
    fclose($fd);
}

function convertCurrency($amount, $from, $to) {
    global $currencyRates;
    return $amount * $currencyRates[$to][$from];
}
?>