#!/usr/bin/php
<?php
/*
 *  Created by Michael Tyson on 1/01/09.
 *  Copyright 2009 Michael Tyson. All rights reserved.
 */

// Configure your home currency here
define("HOME_CURRENCY", $argv[1]);

define("START_DATE", 11);
define("END_DATE", 12);
define("PRODUCT", 6);
define("NUMBER_SALES", 9);
define("ROYALTY", 10);
define("CURRENCY", 13);

include("currency.php");
prepareCurrencies();

// Read input
$contents = explode("\n", file_get_contents($argv[2]));

// Skip header
array_shift($contents);

// Read data
$data = array();
foreach ( $contents as $line ) {
	if ( !trim($line) ) continue;
	$line = explode("\t", trim($line));
	$startDate = $line[START_DATE];
	$endDate = $line[END_DATE];
	$data[$line[PRODUCT]][$line[CURRENCY]] += $line[NUMBER_SALES] * $line[ROYALTY];
}

$date = ($startDate == $endDate ? $endDate : "$startDate - $endDate");

echo "#### $date\n";

// Process data
foreach ( $data as $product => $currencies ) {
	$sum = 0;
	// Iterate through all currencies for product and convert to home currency
	foreach ( $currencies as $currency => $amount ) {
		$sum += convertCurrency($amount, $currency, HOME_CURRENCY);
	}
	
	printf("_%s_&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%0.2f %s\n", $product, $sum, HOME_CURRENCY);
}

?>